/*! Copyright 2013 Amazon Digital Services, Inc. All rights reserved. */
APICallHandler=(function(){var e=function(r,o,q){var t=r;var s=o;var n=q;var p="APICall";this["getHandledType"]=function(){return p};this["handleRequest"]=function(x){var Z=$.Deferred();if(!(x instanceof Request)){console.log("APICallHandler: handleRequest: input was not of type Request");var K=new Result(constants.NativeCallResultCode.ERROR,{});Z.resolve(K)}else{var v=x.getType();var aa=x.getParams();console.log("APICallHandler: handleRequest: message is: "+JSON.stringify(aa));var z=""+aa[constants.ServiceActionCode.ACTION_CODE_KEY];var L={};switch(z){case constants.ServiceActionCode.AUTHORIZE_SESSION:t.onInitialize();t.getInitializationPromise().always(function(){var ab={};ab[constants.BindingKeys.AUTHORIZE_RESULT_BUNDLE_KEY]=constants.AuthorizeKeys.AUTHORIZED;var ac=constants.NativeCallResultCode.SUCCESS;var ad=new Result(ac,ab);Z.resolve(ad)});break;case constants.ServiceActionCode.START_SESSION:s.startSession(aa[constants.BindingKeys.REQUEST_TIMESTAMP]);t.startSession();var R=new Result(constants.NativeCallResultCode.SUCCESS,{});Z.resolve(R);break;case constants.ServiceActionCode.STOP_SESSION:s.stopSession(aa[constants.BindingKeys.REQUEST_TIMESTAMP]);var R=new Result(constants.NativeCallResultCode.SUCCESS,{});Z.resolve(R);break;case constants.ServiceActionCode.SHOW_SIGN_IN_PAGE:t.showSignInPage();var R=new Result(constants.NativeCallResultCode.SUCCESS,{});Z.resolve(R);break;case constants.ServiceActionCode.SHOW_TOS_PAGE:t.showOverlay(constants.OverlayActionCode.SHOW_TERMS_OF_SERVICE);var R=new Result(constants.NativeCallResultCode.SUCCESS,{});Z.resolve(R);break;case constants.ServiceActionCode.SET_OPT_IN:var y=aa[constants.NativeCallKeys.HAS_OPTED_IN];t.setOptIn(y);R=new Result(constants.NativeCallResultCode.SUCCESS,{});Z.resolve(R);break;case constants.ServiceActionCode.AUTHENTICATE:t.authenticate();var R=new Result(constants.NativeCallResultCode.SUCCESS,{});Z.resolve(R);break;case constants.ServiceActionCode.UPDATE_COUNTRY_OF_RESIDENCE:t.updateCOR(x.getParams()[constants.BindingKeys.COUNTRY_OF_RESIDENCE]);var R=new Result(constants.NativeCallResultCode.SUCCESS,{});Z.resolve(R);break;case constants.ServiceActionCode.IS_WHISPERSYNC_ENABLED:n.getGuestMode().always(function(ab){n.isKindle().always(function(ad){var ac=$.Deferred();if(ad){n.isKindleWhispersyncSettingEnabled().always(function(ae){ac.resolve(ae)})}else{n.getWhispersyncEnabledUserSetting().always(function(ae){ac.resolve(ae)})}ac.always(function(af){var ae={};if(ab||!af){ae[constants.BindingKeys.WHISPERSYNC_ENABLED]=false}else{ae[constants.BindingKeys.WHISPERSYNC_ENABLED]=true}var ag=new Result(constants.NativeCallResultCode.SUCCESS,ae);Z.resolve(ag)})})});break;case constants.ServiceActionCode.SHOW_OVERLAY_ACHIEVEMENTS:var Y={};Y[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_ACHIEVEMENTS;hostinterface.showOverlay(JSON.stringify(Y));break;case constants.ServiceActionCode.SHOW_OVERLAY_PROFILE:var Y={};Y[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_PROFILE;hostinterface.showOverlay(JSON.stringify(Y));break;case constants.ServiceActionCode.SHOW_OVERLAY_LEADERBOARDS:var Y={};Y[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_LEADERBOARDS;hostinterface.showOverlay(JSON.stringify(Y));break;case constants.ServiceActionCode.SHOW_OVERLAY_RANKS:var Y={};Y[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_LEADERBOARD_RANKS;Y[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY]=x.getParams()[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY];hostinterface.showOverlay(JSON.stringify(Y));break;case constants.ServiceActionCode.SHOW_GAME_CIRCLE:case constants.ServiceActionCode.SHOW_OVERLAY_SUMMARY:var Y={};Y[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_SUMMARY;hostinterface.showOverlay(JSON.stringify(Y));var R=new Result(constants.NativeCallResultCode.SUCCESS,{});Z.resolve(R);break;case constants.ServiceActionCode.HANDLE_TOAST_CLICK:var L={};var J=x.getParams()[constants.ToastKeys.ACTION_MAPPINGS_KEY];var W=x.getParams()[constants.ToastKeys.TOAST_CLICK_DATA_KEY];var U=ServiceFactory.getRequestFactory().createToastClickRequest(J,W);ServiceFactory.getRequestRouter().handleRequest(U).always(function(ab){Z.resolve({})});break;case constants.ServiceActionCode.HANDLE_TOAST_DISPLAY_METRIC:var L={};var E=x.getParams()[constants.ToastKeys.TOAST_REQUEST_DISPLAYED];var H=ServiceFactory.getRequestFactory().createToastMetricRequest(E);ServiceFactory.getRequestRouter().handleRequest(H).always(function(ab){Z.resolve({})});break;case constants.ServiceActionCode.PROCESS_OFFLINE_EVENT:var L={};var C=ServiceFactory.getRequestFactory().createProcessOfflineEventRequest(x.getParams()["jsonEvent"]);ServiceFactory.getRequestRouter().handleRequest(C).always(function(ab){Z.resolve(l(ab))});break;case constants.ServiceActionCode.REQUEST_ACHIEVEMENT:var Q=x.getParams()[constants.AchievementsBindingKeys.ACHIEVEMENT_ID_KEY];var O=x.getParams()[constants.ProfilesBindingKeys.PLAYER_ID_KEY];var P=ServiceFactory.getRequestFactory().createGetAchievementRequest(Q,O,false);var N=ServiceFactory.getRequestRouter().handleRequest(P);N.done(function(ab){Z.resolve(j(ab))});break;case constants.ServiceActionCode.REQUEST_ACHIEVEMENTS:var Q=x.getParams()[constants.AchievementsBindingKeys.ACHIEVEMENT_ID_KEY];var O=x.getParams()[constants.ProfilesBindingKeys.PLAYER_ID_KEY];var T=ServiceFactory.getRequestFactory().createGetAchievementsRequest(O,false);var N=ServiceFactory.getRequestRouter().handleRequest(T);N.done(function(ab){Z.resolve(c(ab))});break;case constants.ServiceActionCode.UPDATE_ACHIEVEMENT_PROGRESS:var B=ServiceFactory.getRequestFactory().createUpdateAchievementsRequest(x.getParams()["ACHIEVEMENT_ID"],x.getParams()["ACHIEVEMENT_UPDATE_PERCENT"]);var N=ServiceFactory.getRequestRouter().handleRequest(B);N.done(function(ab){Z.resolve(h(ab))});break;case constants.ServiceActionCode.REQUEST_LEADERBOARDS:var D=ServiceFactory.getRequestFactory().createGetLeaderboardsForGameRequest(x.getParams()["GAME_ID"],false);var N=ServiceFactory.getRequestRouter().handleRequest(D);N.done(function(ab){Z.resolve(m(ab))});break;case constants.ServiceActionCode.REQUEST_PLAYER_SCORE:var O=x.getParams()[constants.ProfilesBindingKeys.PLAYER_ID_KEY];var X=x.getParams()[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY];var w=x.getParams()[constants.LeaderboardBindingKeys.LEADERBOARD_FILTER_KEY];var A=x.getParams()[constants.BindingKeys.GAME_ID_KEY];var u=ServiceFactory.getRequestFactory().createGetHighScoreRequest(O,A,X,w,false);var N=ServiceFactory.getRequestRouter().handleRequest(u);N.done(function(ab){Z.resolve(f(ab))});break;case constants.ServiceActionCode.REQUEST_SCORES:x.getParams()["LEADERBOARD_START_RANK"]=1;x.getParams()["LEADERBOARD_SCORES_COUNT"]=100;var G=ServiceFactory.getRequestFactory().createGetLeaderboardRanksRequest(x.getParams()["GAME_ID"],x.getParams()["LEADERBOARD_ID"],x.getParams()["LEADERBOARD_FILTER"],x.getParams()["LEADERBOARD_START_RANK"],x.getParams()["LEADERBOARD_SCORES_COUNT"],false,false);var N=ServiceFactory.getRequestRouter().handleRequest(G);N.done(function(ab){Z.resolve(g(ab,x.getParams()["LEADERBOARD_START_RANK"]))});break;case constants.ServiceActionCode.REQUEST_PERCENTILES:var O=x.getParams()[constants.ProfilesBindingKeys.PLAYER_ID_KEY];var X=x.getParams()[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY];var w=x.getParams()[constants.LeaderboardBindingKeys.LEADERBOARD_FILTER_KEY];var A=x.getParams()[constants.BindingKeys.GAME_ID_KEY];var F=ServiceFactory.getRequestFactory().createGetLeaderboardPercentilesRequest(O,A,X,w,false,false);var N=ServiceFactory.getRequestRouter().handleRequest(F);N.done(function(ab){Z.resolve(i(ab))});break;case constants.ServiceActionCode.SUBMIT_SCORE:var M=ServiceFactory.getRequestFactory().createSubmitScoreRequest(x.getParams()["LEADERBOARD_ID"],x.getParams()["LEADERBOARD_SUBMIT_SCORE"]);var N=ServiceFactory.getRequestRouter().handleRequest(M);N.done(function(ab){Z.resolve(d(ab,x.getParams()["LEADERBOARD_SUBMIT_SCORE"]))});break;case constants.ServiceActionCode.REQUEST_LOCAL_PLAYER_PROFILE:var S=ServiceFactory.getGCSettings().getGuestMode();S.always(function(ab){if(ab){var ac={};ac[constants.BindingKeys.REQUEST_ID_KEY]=x.getParams()[constants.BindingKeys.REQUEST_ID_KEY];ac[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.NOT_AUTHENTICATED;hostinterface.sendReply(JSON.stringify(ac))}else{var ae=ServiceFactory.getRequestFactory().createGetProfileRequest(false);var ad=ServiceFactory.getRequestRouter().handleRequest(ae);ad.always(function(af){var ah=af.getResultMap();if(ah.hidden){var ag={};ag[constants.BindingKeys.REQUEST_ID_KEY]=x.getParams()[constants.BindingKeys.REQUEST_ID_KEY];ag[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.NOT_AUTHENTICATED;hostinterface.sendReply(JSON.stringify(ag))}else{var ag={};ag[constants.BindingKeys.REQUEST_ID_KEY]=x.getParams()[constants.BindingKeys.REQUEST_ID_KEY];if($.isEmptyObject(ah)){ag[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.SERVICE_REQUEST_FAILURE}else{ag[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.SERVICE_REQUEST_SUCCESS;ag[constants.ProfilesBindingKeys.ALIAS_KEY]=ah.alias;ag[constants.ProfilesBindingKeys.PLAYER_ID_KEY]=ah.playerId;ag[constants.ProfilesBindingKeys.AVATAR_URL_KEY]=ah.avatarUrl}hostinterface.sendReply(JSON.stringify(ag))}})}});break;case constants.ServiceActionCode.REQUEST_LOCAL_PLAYER_FRIENDS_PROFILES:var S=ServiceFactory.getGCSettings().getGuestMode();var V=x.getParams()[constants.ProfilesBindingKeys.FRIENDS_PLAYER_IDS_KEY];S.always(function(ab){if(ab){var ae={};ae[constants.BindingKeys.REQUEST_ID_KEY]=x.getParams()[constants.BindingKeys.REQUEST_ID_KEY];ae[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.NOT_AUTHENTICATED;hostinterface.sendReply(JSON.stringify(ae))}else{var ac=ServiceFactory.getSessionCache().friendProfilesFromCache(V);if(ac.success===true){hostinterface.logMessage("Able to successfully resolve batch friends request from session cache");var ae={};ae[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.SERVICE_REQUEST_SUCCESS;ae[constants.BindingKeys.REQUEST_ID_KEY]=x.getParams()[constants.BindingKeys.REQUEST_ID_KEY];ae[constants.ProfilesBindingKeys.FRIENDS_PROFILES_KEY]=ac.profiles;hostinterface.sendReply(JSON.stringify(ae))}else{hostinterface.logMessage("Unable to successfully resolve batch friends request from session cache");var ad=ServiceFactory.getRequestFactory().createGetMyFriendProfilesRequest(V,false);var af=ServiceFactory.getRequestRouter().handleRequest(ad);af.always(function(ag){var al={};al[constants.BindingKeys.REQUEST_ID_KEY]=x.getParams()[constants.BindingKeys.REQUEST_ID_KEY];var ak=ag.getResultMap();if($.isEmptyObject(ak)||!(ak instanceof Array)){al[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.SERVICE_REQUEST_FAILURE}else{var aj=ak[0];if($.isEmptyObject(aj)){al[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.SERVICE_REQUEST_FAILURE}else{var ah=aj.playerIdentities;if($.isEmptyObject(ah)||!(ah instanceof Array)){al[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.SERVICE_REQUEST_FAILURE}else{var ai=[];$.each(ah,function(am,ao){var an={};an[constants.ProfilesBindingKeys.ALIAS_KEY]=ao.alias;an[constants.ProfilesBindingKeys.PLAYER_ID_KEY]=ao.playerId;an[constants.ProfilesBindingKeys.AVATAR_URL_KEY]=ao.avatarUrl;ai.push(an)});al[constants.ProfilesBindingKeys.FRIENDS_PROFILES_KEY]=ai;al[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.SERVICE_REQUEST_SUCCESS}}}hostinterface.sendReply(JSON.stringify(al))})}}});break;case constants.ServiceActionCode.REQUEST_LOCAL_PLAYER_FRIENDS:var I=ServiceFactory.getRequestFactory().createFriendsForGameRequest();var N=ServiceFactory.getRequestRouter().handleRequest(I);N.done(function(ab){Z.resolve(a(ab))});break;default:console.log("Message not supported what="+z);console.log("APICallHandler: handleRequest: actionCode not supported");var K=new Result(constants.NativeCallResultCode.ERROR,{});Z.resolve(K)}}console.log("End of API handler call");return Z.promise()}};var l=function(n){var o={};var p=constants.NativeCallResultCode.ERROR;if(n instanceof Result){p=n.getType()}var q=new Result(p,o);return q};var b=function(o,q){var n={};if(o!==undefined&&q!==undefined&&o&&q){n[constants.AchievementsBindingKeys.ACHIEVEMENT_ID_KEY]=o.id;n[constants.AchievementsBindingKeys.ACHIEVEMENT_TITLE_KEY]=o.title;n[constants.AchievementsBindingKeys.ACHIEVEMENT_DESCRIPTION_KEY]=o.description;n[constants.AchievementsBindingKeys.ACHIEVEMENT_POINTS_KEY]=o.pointValue;n[constants.AchievementsBindingKeys.ACHIEVEMENT_HIDDEN_KEY]=o.hiddenValue;n[constants.AchievementsBindingKeys.ACHIEVEMENT_POSITION_KEY]=o.position;n[constants.AchievementsBindingKeys.ACHIEVEMENT_UNLOCKED_KEY]=q.unlocked;n[constants.AchievementsBindingKeys.ACHIEVEMENT_UPDATE_PERCENT_KEY]=q.progress;if(n[constants.AchievementsBindingKeys.ACHIEVEMENT_UNLOCKED_KEY]){n[constants.AchievementsBindingKeys.ACHIEVEMENT_DATE_UNLOCKED_KEY]=q.dateUnlocked;n[constants.AchievementsBindingKeys.ACHIEVEMENT_ICON_URL_LARGE_KEY]=o.largeIconUrl}else{n[constants.AchievementsBindingKeys.ACHIEVEMENT_DATE_UNLOCKED_KEY]=0;n[constants.AchievementsBindingKeys.ACHIEVEMENT_ICON_URL_LARGE_KEY]=o.lockedLargeIconUrl}for(var p in n){if(n.hasOwnProperty(p)&&(n[p]===undefined||n[p]===null)){n={error:"error"};break}}}else{n={error:"error"}}return n};var c=function(n){var p={};var s=constants.NativeCallResultCode.ERROR;if(n instanceof Result&&n.getType()===constants.NativeCallResultCode.SUCCESS){s=constants.NativeCallResultCode.SUCCESS;var o=[];var r=n.getResultMap()["achievements"]||null;var q=r&&r.achievements;if(Array.isArray(q)){$.each(q,function(v,w){var u=w.achievementMeta;var x=w.playerInfo;var t=b(u,x);if(t.hasOwnProperty("error")){s=constants.NativeCallResultCode.ERROR}o.push(t)})}else{s=constants.NativeCallResultCode.ERROR}if(s===constants.NativeCallResultCode.SUCCESS){p[constants.AchievementsBindingKeys.ACHIEVEMENT_LIST_KEY]=o}}return new Result(s,p)};var j=function(n){var o={};var q=constants.NativeCallResultCode.ERROR;if(n instanceof Result&&n.getType()===constants.NativeCallResultCode.SUCCESS){q=constants.NativeCallResultCode.SUCCESS;var p=n.getResultMap()["achievement"]||null;if(p){o=b(p.achievementMeta,p.playerInfo);if(o.hasOwnProperty("error")){q=constants.NativeCallResultCode.ERROR;o={}}}else{q=constants.NativeCallResultCode.ERROR;o={}}}return new Result(q,o)};var h=function(n){var o={};var p=constants.NativeCallResultCode.ERROR;if(n instanceof Result&&n.getType()===constants.NativeCallResultCode.SUCCESS){p=constants.NativeCallResultCode.SUCCESS;o[constants.AchievementsBindingKeys.ACHIEVEMENT_NEWLY_UNLOCKED_KEY]=n.getResultMap()["newlyUnlocked"];if(o[constants.AchievementsBindingKeys.ACHIEVEMENT_NEWLY_UNLOCKED_KEY]===undefined||o[constants.AchievementsBindingKeys.ACHIEVEMENT_NEWLY_UNLOCKED_KEY]===null){p=constants.NativeCallResultCode.ERROR;o={}}}return new Result(p,o)};var k=function(o){var n={};if(o!==undefined&&o){n[constants.LeaderboardBindingKeys.LEADERBOARD_DISPLAY_TEXT_KEY]=o.DisplayText;n[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY]=o.LeaderboardId;n[constants.LeaderboardBindingKeys.LEADERBOARD_NAME_KEY]=o.Name;n[constants.LeaderboardBindingKeys.LEADERBOARD_DATA_FORMAT_KEY]=o.DataFormat;n[constants.LeaderboardBindingKeys.LEADERBOARD_ICON_URL_KEY]=o.IconUrl;for(var p in n){if(n.hasOwnProperty(p)&&(n[p]===undefined||n[p]===null)){n={error:"error"};break}}}else{n={error:"error"}}return n};var m=function(o){var q={};var r=constants.NativeCallResultCode.ERROR;if(o instanceof Result&&o.getType()===constants.NativeCallResultCode.SUCCESS){r=constants.NativeCallResultCode.SUCCESS;var p=[];var n=o.getResultMap()["LeaderboardList"]||null;if(n){$.each(n,function(u,t){var s=k(t.LeaderboardInfo);if(s.hasOwnProperty("error")){r=constants.NativeCallResultCode.ERROR}else{p.push(s)}})}else{r=constants.NativeCallResultCode.ERROR}if(r===constants.NativeCallResultCode.SUCCESS){q[constants.LeaderboardBindingKeys.LEADERBOARD_LIST_KEY]=p}}return new Result(r,q)};var f=function(n){var o={};var q=constants.NativeCallResultCode.ERROR;if(n instanceof Result&&n.getType()===constants.NativeCallResultCode.SUCCESS){q=constants.NativeCallResultCode.SUCCESS;o[constants.LeaderboardBindingKeys.LEADERBOARD_SUBMIT_SCORE_KEY]=n.getResultMap()["PlayerScore"];o[constants.LeaderboardBindingKeys.LEADERBOARD_PLAYER_RANK_KEY]=n.getResultMap()["PlayerRank"];for(var p in o){if(o.hasOwnProperty(p)&&(o[p]===undefined||o[p]===null)){q=constants.NativeCallResultCode.ERROR;o={};break}}}return new Result(q,o)};var g=function(v,o){var r=function(w,y){var z={scoreList:[]};if(w===undefined||w===null||typeof w!=="object"||y===undefined||typeof y!=="number"){z={error:"error"}}else{var x=y;$.each(w,function(B,A){var D={};D[constants.LeaderboardBindingKeys.LEADERBOARD_SCORE_VALUE_KEY]=A.Score;D[constants.LeaderboardBindingKeys.LEADERBOARD_KEY]=A.Score;D[constants.LeaderboardBindingKeys.LEADERBOARD_SCORE_RANK_KEY]=x;D[constants.ProfilesBindingKeys.ALIAS_KEY]=A.Username;D[constants.ProfilesBindingKeys.PLAYER_ID_KEY]=A.PlayerId;D[constants.ProfilesBindingKeys.AVATAR_URL_KEY]=A.AvatarUrl||"";z.scoreList.push(D);x++;for(var C in D){if(D.hasOwnProperty(C)&&(D[C]===undefined||D[C]===null)){z.error="error";break}}})}return z};var n={};var u=constants.NativeCallResultCode.ERROR;if(v instanceof Result&&v.getType()===constants.NativeCallResultCode.SUCCESS){u=constants.NativeCallResultCode.SUCCESS;var q=k(v.getResultMap()["LeaderboardInfo"]);var s=r(v.getResultMap()["RankList"],o);var p=!s.hasOwnProperty("error")&&!q.hasOwnProperty("error");p=p&&s.hasOwnProperty("scoreList")&&Array.isArray(s.scoreList);if(p){for(var t in q){if(q.hasOwnProperty(t)){n[t]=q[t]}}n[constants.LeaderboardBindingKeys.LEADERBOARD_SCORES_ARRAY_KEY]=s.scoreList}else{u=constants.NativeCallResultCode.ERROR}}return new Result(u,n)};var i=function(v){var r=function(w){var x={percentileList:[]};if(w===undefined||w===null||typeof w!=="object"){x={error:"error"}}else{$.each(w,function(y,B){var A={};A[constants.LeaderboardBindingKeys.LEADERBOARD_PERCENTILE_KEY]=B.Percentile;A[constants.LeaderboardBindingKeys.LEADERBOARD_PERCENTILE_PLAYER_SCORE_KEY]=B.PlayerScore;A[constants.LeaderboardBindingKeys.LEADERBOARD_PERCENTILE_PLAYER_NAME_KEY]=B.PlayerName;A[constants.LeaderboardBindingKeys.LEADERBOARD_PERCENTILE_PLAYER_ID_KEY]=B.PlayerId;A[constants.LeaderboardBindingKeys.LEADERBOARD_PERCENTILE_PLAYER_AVATAR_URL_KEY]=B.AvatarUrl||"";for(var z in A){if(A.hasOwnProperty(z)&&(A[z]===undefined||A[z]===null)){x.error="error";break}}x.percentileList.push(A)})}return x};var o={};var u=constants.NativeCallResultCode.ERROR;if(v instanceof Result&&v.getType()===constants.NativeCallResultCode.SUCCESS){u=constants.NativeCallResultCode.SUCCESS;var q=k(v.getResultMap()["LeaderboardInfo"]);var s=r(v.getResultMap()["PercentileList"]);var n=v.getResultMap()["UserIndex"];var p=!s.hasOwnProperty("error")&&!q.hasOwnProperty("error");p=p&&s.hasOwnProperty("percentileList")&&Array.isArray(s.percentileList);p=p&&n!==undefined&&typeof n==="number";if(p){for(var t in q){if(q.hasOwnProperty(t)){o[t]=q[t]}}o[constants.LeaderboardBindingKeys.LEADERBOARD_PERCENTILES_ARRAY_KEY]=s.percentileList;o[constants.LeaderboardBindingKeys.LEADERBOARD_USER_INDEX_KEY]=n}else{u=constants.NativeCallResultCode.ERROR}}return new Result(u,o)};var d=function(n){var o={};var q=constants.NativeCallResultCode.ERROR;if(n instanceof Result&&n.getType()===constants.NativeCallResultCode.SUCCESS){q=constants.NativeCallResultCode.SUCCESS;var p=n.getResultMap()["SubmitScoreResultsList"]||null;if(p){o[constants.LeaderboardBindingKeys.LEADERBOARD_SUBMIT_RESULT_KEY]=p}else{q=constants.NativeCallResultCode.ERROR}}return new Result(q,o)};var a=function(n){var p={};var u=constants.NativeCallResultCode.ERROR;if(n instanceof Result&&n.getType()===constants.NativeCallResultCode.SUCCESS){var s=n.getResultMap();if(s!==undefined&&s!==null&&Array.isArray(s)&&s.length===1){var o=s[0];var r=o.socialMiniGamerCards;if(r!==undefined&&r!==null&&Array.isArray(r)){var q=[];var t=true;$.each(r,function(x,y){t=t&&y!==undefined&&y!==null&&typeof y==="object";if(t){var v=y.playerIdentity;t=v!==undefined&&v!==null&&typeof v==="object";if(t){var w=v.playerId;t=t&&w!==undefined&&w!==null&&typeof w==="string";q[x]=w;ServiceFactory.getSessionCache().addFriendPlayerProfile(v)}}});if(t){u=constants.NativeCallResultCode.SUCCESS;p[constants.ProfilesBindingKeys.FRIENDS_KEY]=q}else{u=constants.NativeCallResultCode.ERROR}}else{u=constants.NativeCallResultCode.ERROR}}else{u=constants.NativeCallResultCode.ERROR}}return new Result(u,p)};return e}());console.log("APICallHandler loaded.");